/*
* ----------------------------------------------------------------------------
* "THE SUSHI-WARE LICENSE" (Revision 42):
* Niklas Roy wrote this file. As long as you retain this notice you
* can do whatever you want with this stuff. If we meet some day, and you think
* this stuff is worth it, you can buy me a sushi in return. 
* ----------------------------------------------------------------------------
*/

#include <Adafruit_NeoPixel.h>
#ifdef __AVR__
#include <avr/power.h>
#endif
#define DATA_PIN 2
#define NUM_LEDS 15 /*552wks*/
#define BRIGHTNESS 100
#define SPEAKER 3

Adafruit_NeoPixel strip = Adafruit_NeoPixel(NUM_LEDS, DATA_PIN, NEO_GRB + NEO_KHZ800);


int state = 0;
int d = 1;

int pos = 0;
const int leftButton = 4;   // "left"
const int rightButton = 5;  // "right"
const int upButton = 6;     // "up"
const int downButton = 7;   // "down"
const int solenoidPin = 13;  // solenoid is connected to pin 2 via transistor

unsigned long bmiTimer;
unsigned long sushiTimer;

void setup() {
  // initialize serial communication at 9600 bits per second
  Serial.begin(115200);
  strip.setBrightness(BRIGHTNESS);
  strip.begin();


  pinMode(solenoidPin, OUTPUT);

  // activate internal pullup resistors for the joystick button pins
  pinMode(leftButton, INPUT_PULLUP);
  pinMode(rightButton, INPUT_PULLUP);
  pinMode(upButton, INPUT_PULLUP);
  pinMode(downButton, INPUT_PULLUP);

  // put your setup code here, to run once:
  pinMode(8, OUTPUT);
  pinMode(9, OUTPUT);
  pinMode(10, OUTPUT);
  pinMode(11, OUTPUT);

  //Sushi LED's
  pinMode(A1, OUTPUT);
  pinMode(A2, OUTPUT);
  pinMode(A3, OUTPUT);
  pinMode(A4, OUTPUT);
  pinMode(A5, OUTPUT);

  pinMode(SPEAKER, OUTPUT);





  Serial.println("Barbie Game Setup Done!");

}
////////////////////////////////////////////////////////////////////// LOOP!
void loop() {

  int bmi;
  while (state == 0) {//------------------------------------------ reset
    /*  pos = 0;
      for (int i = 0; i < 2700; i++) {
        pos--;
        stepper();
        delay(1);
      }
      for (int i = 0; i < 1150; i++) {
        pos++;
        stepper();
        delay(1);
      }*/
    state = 1;
  }

  while (state == 1) {//------------------------------------------ attract mode
    if ( digitalRead(upButton) == LOW) {
      state++;
    }
    unsigned long time = millis();
    bmi = ((time / 100) % 30);
    if (bmi > 15) {
      bmi = 30 - bmi;
    }
    showBMI(bmi);
    switchLed((time / 200) % 5);
    unsigned long lpos = (time / 10) % 2500;
    pos = lpos;
    if (pos > 1250) {
      pos = 2500 - pos;
    }
    stepper();
  }


  //-------setup game

  showBMI(0);
  switchLed(0);
  tone(SPEAKER, 750);
  delay(100);
  tone(SPEAKER, 500);
  delay(100);  tone(SPEAKER, 750);
  delay(100);
  tone(SPEAKER, 500);
  delay(100);
  tone(SPEAKER, 750);
  delay(100);
  tone(SPEAKER, 500);
  delay(100);
  tone(SPEAKER, 1000);
  delay(200);
  noTone(SPEAKER);

  int sushi = random(1, 5);
  switchLed(sushi);
  sushiTimer = millis() + 5000;


  bmi = 10;
  showBMI(bmi);
  bmiTimer = millis() + 1000;

  while (state == 2) {//------------------------------------------ game loop
    // bmi
    if (bmi <= 0) {
      state = 3;
    }
    if (bmi > 15) {
      state = 4;
    }

    if (millis() > bmiTimer) {
      bmi--;
      bmiTimer = millis() + 1000;
      if(bmi<6){bmiTimer+=(6-bmi)*250;}
      showBMI(bmi);
    }

    //sushi
    if (millis() > sushiTimer) {
      sushi += random(0, 3);
      sushi = sushi % 5 + 1;
      switchLed(sushi);
      sushiTimer = millis() + 5000 - bmi * 200;
    }

    // joystick:
    if (digitalRead(leftButton) == LOW) {     // check if the left button is pressed
      pos++;
    }

    if (digitalRead(rightButton) == LOW) {     // check if the right button is pressed
      pos--;
    }


    if (digitalRead(downButton) == LOW) {     // eat!
      digitalWrite(solenoidPin, HIGH);
      if (getLedState() == HIGH) {            // eating success!
        tone(SPEAKER, 500);
        delay(100);
        switchLed(0);
        tone(SPEAKER, 750);
        delay(100);
        tone(SPEAKER, 1000);
        delay(200);
        noTone(SPEAKER);
        //new random sushi
        sushi += random(0, 3);
        sushi = sushi % 5 + 1;
        switchLed(sushi);
        sushiTimer = millis() + 5000 - bmi * 200;
        bmi += 1;
        showBMI(bmi);
        bmiTimer = millis() + 2500;

      } else {                                // missed sushi!
        delay(200);
        tone(SPEAKER, 1000);
        delay(100);
        tone(SPEAKER, 750);
        delay(100);
        tone(SPEAKER, 500);
        delay(200);
        noTone(SPEAKER);
        bmi -= 2;
        showBMI(bmi);
        bmiTimer = millis() + 1000;
      }
      digitalWrite(solenoidPin, LOW);

    }

    stepper();
    d = 900;
    delayMicroseconds(d);
  }


  while (state == 3) {//------------------------------------------ game over
    switchLed(0);
    delay(500);
    tone(SPEAKER, 500);
    delay(500);
    tone(SPEAKER, 250);
    delay(500);
    tone(SPEAKER, 125);
    delay(750);
    noTone(SPEAKER);
    delay(2000);
    state = 0;
  }


  while (state == 4) {//------------------------------------------ won!
    for (int i = 0; i < 1000; i += 50) {
      tone(SPEAKER, i * 3 + 100 + random(500));
      delay(50);
      switchLed((i / 50) % 5 + 1);
      showBMI((i / 50) % 16);
    }

    for (int i = 0; i < 1000; i += 50) {
      tone(SPEAKER, i * 5 + 100 + random(500));
      delay(50);
      switchLed((i / 50) % 5 + 1);
      showBMI((i / 50) % 16);
    }

    for (int i = 0; i < 1000; i += 50) {
      tone(SPEAKER, i * 10 + 100 + random(500));
      delay(50);
      switchLed((i / 50) % 5 + 1);
      showBMI(((i / 50) -4)% 16);
    }

    noTone(SPEAKER);
    delay(2000);
    state = 0;
  }












  //Serial.print("300,1000,750,");
  //Serial.println(analogRead(A0));
  //Serial.print(getLedState());
  //Serial.println("--");

}





//// FUNCTIONS

void showBMI(int value) {
  for (int i = 0; i < 15; i++) {
    strip.setPixelColor(i, 0, 0, 0);
  }
  for (int i = 0; i < value; i++) {
    if (i < 5) {
      strip.setPixelColor(i, 255, 0, 0);
    }
    if (i > 4 && i < 10) {
      strip.setPixelColor(i, 255, 255, 0);
    }
    if (i > 9) {
      strip.setPixelColor(i, 0, 255, 0);
    }
  }

  strip.show(); // Initialize all pixels to 'off'
}
/////////

void switchLed(int index) {
  switch (index) {
    case 0:
      digitalWrite(A1, LOW);
      digitalWrite(A2, LOW);
      digitalWrite(A3, LOW);
      digitalWrite(A4, LOW);
      digitalWrite(A5, LOW);
      break;

    case 1:
      digitalWrite(A1, HIGH);
      digitalWrite(A2, LOW);
      digitalWrite(A3, LOW);
      digitalWrite(A4, LOW);
      digitalWrite(A5, LOW);
      break;
    case 2:
      digitalWrite(A1, LOW);
      digitalWrite(A2, HIGH);
      digitalWrite(A3, LOW);
      digitalWrite(A4, LOW);
      digitalWrite(A5, LOW);
      break;
    case 3:
      digitalWrite(A1, LOW);
      digitalWrite(A2, LOW);
      digitalWrite(A3, HIGH);
      digitalWrite(A4, LOW);
      digitalWrite(A5, LOW);
      break;
    case 4:
      digitalWrite(A1, LOW);
      digitalWrite(A2, LOW);
      digitalWrite(A3, LOW);
      digitalWrite(A4, HIGH);
      digitalWrite(A5, LOW);
      break;
    case 5:
      digitalWrite(A1, LOW);
      digitalWrite(A2, LOW);
      digitalWrite(A3, LOW);
      digitalWrite(A4, LOW);
      digitalWrite(A5, HIGH);
      break;
  }
}
///
boolean getLedState() {
  boolean value = false;
  if (analogRead(A0) < 800) {
    value = true;
  }
  return value;
}
////////////////7

void stepper() {
  if (pos < 0) {
    pos += 8;
  }
  switch (pos % 8) {
    case 0:
      digitalWrite(8, HIGH);
      digitalWrite(9, LOW);
      digitalWrite(10, LOW);
      digitalWrite(11, LOW);
      break;
    case 1:
      digitalWrite(8, HIGH);
      digitalWrite(9, HIGH);
      digitalWrite(10, LOW);
      digitalWrite(11, LOW);
      break;
    case 2:

      digitalWrite(8, LOW);
      digitalWrite(9, HIGH);
      digitalWrite(10, LOW);
      digitalWrite(11, LOW);
      break;
    case 3:

      digitalWrite(8, LOW);
      digitalWrite(9, HIGH);
      digitalWrite(10, HIGH);
      digitalWrite(11, LOW);
      break;
    case 4:

      digitalWrite(8, LOW);
      digitalWrite(9, LOW);
      digitalWrite(10, HIGH);
      digitalWrite(11, LOW);

      break;
    case 5:
      digitalWrite(8, LOW);
      digitalWrite(9, LOW);
      digitalWrite(10, HIGH);
      digitalWrite(11, HIGH);

      break;
    case 6:
      digitalWrite(8, LOW);
      digitalWrite(9, LOW);
      digitalWrite(10, LOW);
      digitalWrite(11, HIGH);

      break;
    case 7:
      digitalWrite(8, HIGH);
      digitalWrite(9, LOW);
      digitalWrite(10, LOW);
      digitalWrite(11, HIGH);
      break;
  }
}
